package de.uka.ipd.sdq.simucomframework.abstractSimEngine;

public interface ISimProcessDelegate {

	// Strategy dependent methods
	public abstract void passivate();

	/**
	 * Resumes the process after waiting <code>delay</code> simulated time
	 * units.
	 * 
	 * @param delay
	 */
	public abstract void scheduleAt(double delay);

	public abstract boolean isTerminated();

	/**
	 * Triggers a timeout failure of this process delegate.
	 * 
	 * @param timeoutFailureTypeId
	 *            the type of the timeout failure
	 */
	public abstract void setTimeoutFailure(String timeoutFailureTypeId);
}