package de.uka.ipd.sdq.simucomframework.abstractSimEngine;

/**
 * Represents a failure type for a software-induced failure-on-demand
 * occurrence.
 * 
 * This failure type specification corresponds to the specification of
 * SoftwareInducedFailureTypes in a PCM Repository model.
 * 
 * @author brosch
 * 
 */
public class SimSoftwareFailureType extends SimFailureType {

	/**
	 * The ID of this software failure type.
	 */
	private String softwareFailureId;

	/**
	 * The constructor.
	 * 
	 * @param softwareFailureId
	 *            the ID of this software failure type
	 * @param softwareFailureName
	 *            the name of this software failure type as determined in the
	 *            PCM Repository model
	 */
	public SimSoftwareFailureType(final String softwareFailureId,
			final String softwareFailureName) {
		super(softwareFailureId, softwareFailureName + " (software failure)");
		this.softwareFailureId = softwareFailureId;
	}

	/**
	 * Retrieves the software failure type ID.
	 * 
	 * @return the software failure type
	 */
	public String getSoftwareFailureId() {
		return softwareFailureId;
	}
}
